let gulp         = require('gulp');
let elixir       = require('laravel-elixir');
let config       = elixir.config;
const path = require('path');
const fs = require('fs');

/**
 * Generate map files with hash version files
 * @param  {string}        src        The files to uglify
 * @param  {array}         myPathsToBeVersioned The array of path to be versioned
 */

elixir.extend('oasourcemap', function (src,myPathsToBeVersioned) {


    elixir(function (mix) {
        //console.log(myPathsToBeVersioned);

        if (elixir.config.production) {
            //console.log("Production Detected! Sourcemap Not generated!");
        } else if (!fs.existsSync(src)) {// Check that the file exists locally
            //console.log("Manifest Not Found!");
        }
        else {// The file *does* exist
            //console.log("Processing Manifest");
            // Read the file and do anything you want
            var revManifest = JSON.stringify(JSON.parse(fs.readFileSync(src)));


            revManifest = revManifest.replace('{', '').replace('}', '').replace(/\"/g, "").split(",");


            revManifest.forEach(function (element) {
                var paths = element.split(":");

                var source = "./public/" + paths[0] + ".map";
                var destination = "./public/build/" + paths[1] + ".map";

                mix.copy([
                    source,
                ], destination);


            });

        }
    });
});